package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ListView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.ArxiuAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Arxiu;

public class ArxiusActivity extends DropdownMenu {

	private ListView fileList;
	private List<Arxiu> arxius;
	private ArxiuAdapter aa;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		getActionBar().setSelectedNavigationItem(FITXERS);
		getActionBar().setBackgroundDrawable(getResources().getDrawable(R.drawable.actionbar_background));
		
		
		setContentView(R.layout.activity_arxius);
		

		fileList = (ListView) findViewById(R.id.listArxius);
		arxius = generateHardcodedList();

		SharedPreferences prefs = getSharedPreferences("account", MODE_PRIVATE);
		aa = new ArxiuAdapter(this, R.layout.file_row, arxius,
				prefs.getBoolean("isProfessor", false));
		
		fileList.setAdapter(aa);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_arxius, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			// return home, that's AssignaturesActivity
			Intent i = new Intent(this, AssignaturesActivity.class);
			i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			startActivity(i);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	private ArrayList<Arxiu> generateHardcodedList() {
		Arxiu a1 = new Arxiu();
		Arxiu a2 = new Arxiu();

		a1.setId(234234);
		a1.setNom("document introcutori");
		a1.setVisible(true);

		a2.setId(34568);
		a2.setNom("enunciat practica tema X");
		a2.setVisible(true);

		ArrayList<Arxiu> arxius = new ArrayList<Arxiu>();

		arxius.add(a1);
		arxius.add(a2);

		return arxius;
	}
	
}
