package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.List;

import android.app.ActionBar;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.GridView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.AssignaturaAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Alumne;
import com.ub.alumnes.mmorenfe.pfg_app.model.Assignatura;
import com.ub.alumnes.mmorenfe.pfg_app.model.Professor;
import com.ub.alumnes.mmorenfe.pfg_app.model.Tema;

public class AssignaturesActivity extends Activity {

	private GridView gv;
	private AssignaturaAdapter aa;
	private List<Assignatura> assignatures;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_assignatures);

		ActionBar bar = getActionBar();
		bar.setBackgroundDrawable(getResources().getDrawable(
				R.drawable.actionbar_background));

		gv = (GridView) findViewById(R.id.assignatura_grid);

		assignatures = new ArrayList<Assignatura>();
		assignatures = generateHardcodedAssignatureObjects();
		aa = new AssignaturaAdapter(getApplicationContext(),
				R.layout.assignatura_grid_element, assignatures);

		gv.setAdapter(aa);

		gv.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				Intent i = new Intent(getApplicationContext(),
						TemaActivity.class);
				i.putExtra("Assignatura", assignatures.get(position));
				i.putParcelableArrayListExtra("Assignatures", (ArrayList<Assignatura>) assignatures);
				startActivity(i);
			}
		});

	}

	private ArrayList<Assignatura> generateHardcodedAssignatureObjects() {
		ArrayList<Assignatura> assignatures = new ArrayList<Assignatura>();

		Assignatura a1 = new Assignatura(1, "Software concurrent",
				new ArrayList<Tema>(), new ArrayList<Alumne>(),
				new ArrayList<Professor>(), null);

		a1.getProfessors().add(
				new Professor(234234, 234234, "", "Lluis", "Garrido", null,
						null));

		List<Tema> temesA1 = new ArrayList<Tema>();

		Tema t1a1 = new Tema(235235, "introducció al software paralel", null,
				null);
		Tema t2a1 = new Tema(32456, "OpenMP", null, null);
		Tema t3a1 = new Tema(7542, "OpenCV i OpenMPI", null, null);

		temesA1.add(t1a1);
		temesA1.add(t2a1);
		temesA1.add(t3a1);

		a1.setTemes(temesA1);

		Assignatura a2 = new Assignatura(2, "Enginyeria del software",
				new ArrayList<Tema>(), new ArrayList<Alumne>(),
				new ArrayList<Professor>(), null);

		a2.getProfessors()
				.add(new Professor(234234, 234234, "", "Oriol", "Pujol", null,
						null));

		List<Tema> temesA2 = new ArrayList<Tema>();

		Tema t1a2 = new Tema(2335235, "Introduccio", null,
				null);
		Tema t2a2 = new Tema(332456, "Blender i JMonkey Engine", null, null);
		Tema t3a2 = new Tema(73542, "Tecnologia Scrum", null, null);

		temesA2.add(t1a2);
		temesA2.add(t2a2);
		temesA2.add(t3a2);

		a2.setTemes(temesA2);

		Assignatura a3 = new Assignatura(3, "Projecte integrat de software",
				new ArrayList<Tema>(), new ArrayList<Alumne>(),
				new ArrayList<Professor>(), null);
		a3.getProfessors()
				.add(new Professor(234234, 234234, "", "Santi", "Segui", null,
						null));
		
		List<Tema> temesA3 = new ArrayList<Tema>();

		Tema t1a3 = new Tema(2235235, "Introduccio", null,
				null);
		Tema t2a3 = new Tema(322456, "Android, estat del art", null, null);
		Tema t3a3 = new Tema(72542, "Views, Layouts y Activities", null, null);

		temesA3.add(t1a3);
		temesA3.add(t2a3);
		temesA3.add(t3a3);

		a3.setTemes(temesA3);

		Assignatura a4 = new Assignatura(4, "Base de Dades",
				new ArrayList<Tema>(), new ArrayList<Alumne>(),
				new ArrayList<Professor>(), null);

		a4.getProfessors().add(
				new Professor(234234, 234234, "", "Carles", "Franquesa", null,
						null));
		
		List<Tema> temesA4 = new ArrayList<Tema>();

		Tema t1a4 = new Tema(2135235, "Introduccio", null,
				null);
		Tema t2a4 = new Tema(312456, "Diagrames ER", null, null);
		Tema t3a4 = new Tema(71542, "Creacio de bases de dades amb acces", null, null);

		temesA4.add(t1a4);
		temesA4.add(t2a4);
		temesA4.add(t3a4);

		a4.setTemes(temesA4);

		assignatures.add(a1);
		assignatures.add(a2);
		assignatures.add(a3);
		assignatures.add(a4);

		return assignatures;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		SharedPreferences prefs = getSharedPreferences("account", MODE_PRIVATE);

		// Inflate the menu; this adds items to the action bar if it is present.
		if (prefs.getBoolean("isProfessor", false)) {
			getMenuInflater().inflate(R.menu.activity_assignatures, menu);
		} else {
			getMenuInflater()
					.inflate(R.menu.activity_assignatures_alumne, menu);
		}

		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		return super.onOptionsItemSelected(item);
	}

}
