package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.List;

import android.app.Fragment;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.ListView;
import android.widget.TextView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.AvaluacioAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Alumne;
import com.ub.alumnes.mmorenfe.pfg_app.model.Avaluacio;
import com.ub.alumnes.mmorenfe.pfg_app.model.Pregunta;
import com.ub.alumnes.mmorenfe.pfg_app.model.Resposta;
import com.ub.alumnes.mmorenfe.pfg_app.model.Test;
import com.ub.alumnes.mmorenfe.pfg_app.utils.ChartUtils;

public class AvaluacioPerAlumnesDetailFragment extends Fragment {

	private Alumne alumne;

	private boolean isProfessor;

	private WebView chart;
	
	private View containerView;
	
	DoCreateChart task;
	
	AvaluacioAdapter aa;

	/**
	 * Mandatory empty constructor for the fragment manager to instantiate the
	 * fragment (e.g. upon screen orientation changes).
	 */
	public AvaluacioPerAlumnesDetailFragment() {
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		if (getArguments().containsKey("Alumne")) {
			alumne = AvaluacioPerAlumnesListFragment.map.get(getArguments()
					.getInt("Alumne"));
		}
		
		task = new DoCreateChart();
		task.execute(new Alumne());
		
		
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View rootView = inflater.inflate(
				R.layout.fragment_avaluacioperalumnes_detail, container, false);

		SharedPreferences preferences = getActivity().getApplicationContext()
				.getSharedPreferences("account", Context.MODE_PRIVATE);

		isProfessor = preferences.getBoolean("isProfessor", false);

		chart = (WebView) rootView.findViewById(R.id.chart1);

		this.containerView = rootView;
		return rootView;
	}

	private class DoCreateChart extends AsyncTask<Alumne, Void, Void> {

		@Override
		protected Void doInBackground(Alumne... params) {

			
			return null;

		}

		@Override
		protected void onPostExecute(Void result) {
			super.onPostExecute(result);
			List<Float> values = new ArrayList<Float>();
			values.add(1.f);
			values.add(5.f);
			values.add(10.f);

			
			List<Float> mean = new ArrayList<Float>();
			mean.add(5f);
			mean.add(5.f);
			mean.add(5f);

			
			
			ChartUtils utils = new ChartUtils(values, mean);
			chart.loadUrl(utils.getQuery());
		}
	}
	
	
	
	@Override
	public void onStart() {
		super.onStart();
		
		
		aa = new AvaluacioAdapter(getActivity(), R.layout.avaluacio_row, generateHardcodedList());
		
		ListView lv = (ListView) containerView.findViewById(R.id.listViewAvaluacions);
		lv.setAdapter(aa);
		
		TextView nomCognom = (TextView) containerView.findViewById(R.id.textViewNomCognom);
		TextView niub = (TextView) containerView.findViewById(R.id.textViewNIUB);
		
		nomCognom.setText(alumne.getNom() + " " + alumne.getCognom());
		
		niub.setText("NIUB: " + String.valueOf(alumne.getNiub()));
		
	}

	private List<Avaluacio> generateHardcodedList() {
		
		List<Test> tests = generateTestHardcodedList();
		
		List<Avaluacio> avaluacions = new ArrayList<Avaluacio>();
		
		Avaluacio a1 = new Avaluacio(tests.get(0), 1f, 98715);
		
		Avaluacio a2 = new Avaluacio(tests.get(1), 5f, 77451);

        Test t3 = new Test(235235, "Test3", null, false);

        Avaluacio a3 = new Avaluacio(t3, 10f, 77646451);
		
		avaluacions.add(a1);
		avaluacions.add(a2);
        avaluacions.add(a3);

        return avaluacions;
	}
	

	private List<Test> generateTestHardcodedList() {

		// tests
		Test t1;
		Test t2;
        Test t3;

		// test list
		ArrayList<Test> tests = new ArrayList<Test>();

		// respostes per la pregunta 1 del tests 1
		Resposta r1p1t1 = new Resposta(1, "Resposta 1", false);
		Resposta r2p1t1 = new Resposta(2, "Resposta 2", false);
		Resposta r3p1t1 = new Resposta(3, "Resposta 3", true);
		Resposta r4p1t1 = new Resposta(4, "Resposta 4", false);

		List<Resposta> respostes = new ArrayList<Resposta>(4);

		respostes.add(r1p1t1);
		respostes.add(r2p1t1);
		respostes.add(r3p1t1);
		respostes.add(r4p1t1);

		// pregunta 1 del test 1
		Pregunta p1t1 = new Pregunta(1, "pregunta 1", respostes);

		// respostes pre la pregunta 2 del test 1
		Resposta r1p2t1 = new Resposta(5, "Resposta 1", false);
		Resposta r2p2t1 = new Resposta(6, "Resposta 2", false);
		Resposta r3p2t1 = new Resposta(7, "Resposta 3", false);
		Resposta r4p2t1 = new Resposta(8, "Resposta 4", true);

		List<Resposta> respostes2 = new ArrayList<Resposta>(4);

		respostes2.add(r1p2t1);
		respostes2.add(r2p2t1);
		respostes2.add(r3p2t1);
		respostes2.add(r4p2t1);

		Pregunta p2t1 = new Pregunta(2, "pregunta 2", respostes2);

		List<Pregunta> preguntes1 = new ArrayList<Pregunta>();

		preguntes1.add(p1t1);
		preguntes1.add(p2t1);

		// respostes per la pregunta 1 del test 2
		Resposta r1p1t2 = new Resposta(9, "Resposta 1", true);
		Resposta r2p1t2 = new Resposta(10, "Resposta 2", false);
		Resposta r3p1t2 = new Resposta(11, "Resposta 3", false);
		Resposta r4p1t2 = new Resposta(12, "Resposta 4", false);

		List<Resposta> respostes3 = new ArrayList<Resposta>(4);

		respostes3.add(r1p1t2);
		respostes3.add(r2p1t2);
		respostes3.add(r3p1t2);
		respostes3.add(r4p1t2);

		Pregunta p1t2 = new Pregunta(3, "pregunta 1", respostes3);

		// respostes per la pregunta 2 del test 2
		Resposta r1p2t2 = new Resposta(13, "Resposta 1", false);
		Resposta r2p2t2 = new Resposta(14, "Resposta 2", false);
		Resposta r3p2t2 = new Resposta(15, "Resposta 3", true);
		Resposta r4p2t2 = new Resposta(16, "Resposta 4", false);

		List<Resposta> respostes4 = new ArrayList<Resposta>(4);

		respostes4.add(r1p2t2);
		respostes4.add(r2p2t2);
		respostes4.add(r3p2t2);
		respostes4.add(r4p2t2);

		Pregunta p2t2 = new Pregunta(4, "pregunta 2", respostes4);

		List<Pregunta> preguntes2 = new ArrayList<Pregunta>();

		preguntes2.add(p1t2);
		preguntes2.add(p2t2);

		t1 = new Test(1, "test 1", preguntes1, true);
		t2 = new Test(2, "test 2", preguntes2, false);

		tests.add(t1);
		tests.add(t2);

		return tests;
	}
}
