package com.ub.alumnes.mmorenfe.pfg_app;

import android.app.ActionBar;
import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;


public class AvaluacioPerAlumnesListActivity extends Activity implements
		AvaluacioPerAlumnesListFragment.Callbacks {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_avaluacioperalumnes_twopane);
		
		ActionBar bar = getActionBar();
		bar.setBackgroundDrawable(getResources().getDrawable(R.drawable.actionbar_background));
		
		bar.setTitle(getString(R.string.title_section_participants));


        SharedPreferences prefs = getSharedPreferences("account", MODE_PRIVATE);

        boolean isProfessor = prefs.getBoolean("isProfessor", false);

        if (isProfessor) {
            bar.setTitle("Qualificacions");
        }


        // In two-pane mode, list items should be given the
			// 'activated' state when touched.
			((AvaluacioPerAlumnesListFragment) getFragmentManager()
					.findFragmentById(R.id.avaluacioperalumnes_list))
					.setActivateOnItemClick(true);
	}

	/**
	 * Callback method from {@link AvaluacioPerAlumnesListFragment.Callbacks}
	 * indicating that the item with the given ID was selected.
	 */
	@Override
	public void onItemSelected(int id) {
			// In two-pane mode, show the detail view in this activity by
			// adding or replacing the detail fragment using a
			// fragment transaction.
			Bundle arguments = new Bundle();
			arguments.putInt("Alumne", id);
			AvaluacioPerAlumnesDetailFragment fragment = new AvaluacioPerAlumnesDetailFragment();
			fragment.setArguments(arguments);
			getFragmentManager()
					.beginTransaction()
					.replace(R.id.avaluacioperalumnes_detail_container,
							fragment).commit();
	}
}
