package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.app.ListFragment;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.AlumnesAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Alumne;
import com.ub.alumnes.mmorenfe.pfg_app.model.Missatge;
import com.ub.alumnes.mmorenfe.pfg_app.model.Professor;

public class AvaluacioPerAlumnesListFragment extends ListFragment {

	protected static Map<Integer, Alumne> map;

	private AlumnesAdapter aa;

	private List<Alumne> alumnes;

	/**
	 * The serialization (saved instance state) Bundle key representing the
	 * activated item position. Only used on tablets.
	 */
	private static final String STATE_ACTIVATED_POSITION = "activated_position";

	/**
	 * The fragment's current callback object, which is notified of list item
	 * clicks.
	 */
	private Callbacks mCallbacks = sDummyCallbacks;

	/**
	 * The current activated item position. Only used on tablets.
	 */
	private int mActivatedPosition = ListView.INVALID_POSITION;

	/**
	 * A callback interface that all activities containing this fragment must
	 * implement. This mechanism allows activities to be notified of item
	 * selections.
	 */
	public interface Callbacks {
		/**
		 * Callback for when an item has been selected.
		 */
		public void onItemSelected(final int id);
	}

	/**
	 * A dummy implementation of the {@link Callbacks} interface that does
	 * nothing. Used only when this fragment is not attached to an activity.
	 */
	private static Callbacks sDummyCallbacks = new Callbacks() {
		@Override
		public void onItemSelected(final int id) {
		}
	};

	/**
	 * Mandatory empty constructor for the fragment manager to instantiate the
	 * fragment (e.g. upon screen orientation changes).
	 */
	public AvaluacioPerAlumnesListFragment() {
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		SharedPreferences prefs = getActivity().getSharedPreferences("account",
				Context.MODE_PRIVATE);

		aa = new AlumnesAdapter(getActivity(), R.layout.layout_alume_row,
				downloadAlumnes());

		setListAdapter(aa);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Fragment#onStart()
	 */
	@Override
	public void onStart() {
		super.onStart();
		aa.setNotifyOnChange(true);
		setActivateOnItemClick(true);
		
		getListView().setSelector(getResources().getDrawable(R.drawable.list_item_selector));
	}

	@Override
	public void onViewCreated(View view, Bundle savedInstanceState) {
		super.onViewCreated(view, savedInstanceState);

		// Restore the previously serialized activated item position.
		if (savedInstanceState != null
				&& savedInstanceState.containsKey(STATE_ACTIVATED_POSITION)) {
			setActivatedPosition(savedInstanceState
					.getInt(STATE_ACTIVATED_POSITION));
		}
	}

	@Override
	public void onAttach(Activity activity) {
		super.onAttach(activity);

		map = new HashMap<Integer, Alumne>();

		// Activities containing this fragment must implement its callbacks.
		if (!(activity instanceof Callbacks)) {
			throw new IllegalStateException(
					"Activity must implement fragment's callbacks.");
		}

		mCallbacks = (Callbacks) activity;
	}

	private List<Alumne> downloadAlumnes() {
		// TODO: descarregar els alumnes, canviar el metode generatehardcoded
		// list
		// per el metode de descarrega.
		alumnes = new ArrayList<Alumne>();
		alumnes = generateHardcodedList();

		for (Alumne alumne : alumnes) {
			map.put(alumne.getId(), alumne);
		}

		return alumnes;
	}

	public List<Alumne> generateHardcodedList() {

		List<Alumne> alumnes = new ArrayList<Alumne>();

		Alumne a = new Alumne(1, 14740460, "47330568H", "Marc", "Moreno",
				new ArrayList<Missatge>(), new ArrayList<Missatge>());

		Alumne b = new Alumne(2, 252352, "sdfsdgg", "Xavier", "Vales",
				new ArrayList<Missatge>(), new ArrayList<Missatge>());

        Alumne c = new Alumne(3,24563456, "sfsdfsdf", "Oriol", "Janés", null, null);


        SharedPreferences prefs = getActivity().getSharedPreferences("account", Context.MODE_PRIVATE);
        boolean isProfessor = prefs.getBoolean("isProfessor", false);
        if (isProfessor) {
            alumnes.add(a);
            alumnes.add(b);
        }
		alumnes.add(c);
		
		return alumnes;

	}

	@Override
	public void onDetach() {
		super.onDetach();

		// Reset the active callbacks interface to the dummy implementation.
		mCallbacks = sDummyCallbacks;
	}

	@Override
	public void onListItemClick(ListView listView, View view, int position,
			long id) {
		super.onListItemClick(listView, view, position, id);

		// Notify the active callbacks interface (the activity, if the
		// fragment is attached to one) that an item has been selected.
		mCallbacks.onItemSelected(alumnes.get(position).getId());
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		if (mActivatedPosition != ListView.INVALID_POSITION) {
			// Serialize and persist the activated item position.
			outState.putInt(STATE_ACTIVATED_POSITION, mActivatedPosition);
		}
	}

	/**
	 * Turns on activate-on-click mode. When this mode is on, list items will be
	 * given the 'activated' state when touched.
	 */
	public void setActivateOnItemClick(boolean activateOnItemClick) {
		// When setting CHOICE_MODE_SINGLE, ListView will automatically
		// give items the 'activated' state when touched.
		getListView().setChoiceMode(
				activateOnItemClick ? ListView.CHOICE_MODE_SINGLE
						: ListView.CHOICE_MODE_NONE);
	}

	private void setActivatedPosition(int position) {
		if (position == ListView.INVALID_POSITION) {
			getListView().setItemChecked(mActivatedPosition, false);
		} else {
			getListView().setItemChecked(position, true);
		}

		mActivatedPosition = position;
	}

	public void addAlumne(final Alumne alumne) {
		alumnes.add(alumne);
		if (map.containsKey(alumne.getId())) {
			map.remove(alumne.getId());
		}
		aa.notifyDataSetChanged();

	}

	public void setTest(final Alumne alumne) {

		for (int i = 0; i < alumnes.size(); i++) {
			if (alumnes.get(i).getId() == alumne.getId()) {
				alumnes.set(i, alumne);
			}
		}

		aa.notifyDataSetChanged();
	}
}
