package com.ub.alumnes.mmorenfe.pfg_app;

import android.app.ActionBar;
import android.app.Activity;
import android.app.FragmentTransaction;
import android.content.Intent;
import android.os.Bundle;
import android.view.MenuItem;

public class AvaluacioPerTestListActivity extends Activity implements
		AvaluacioPerTestListFragment.Callbacks {
	
	private int selectedTestsId;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
				
		setContentView(R.layout.activity_avaluaciopertest_twopane);
		
		ActionBar bar = getActionBar();
		
		bar.setTitle(getString(R.string.title_activity_avaluacions));

		((AvaluacioPerTestListFragment) getFragmentManager().findFragmentById(
				R.id.avaluaciopertest_list)).setActivateOnItemClick(true);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		switch (item.getItemId()) {
		case android.R.id.home:
			// return home, that's AssignaturesActivity
			Intent i = new Intent(this, AssignaturesActivity.class);
			i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			startActivity(i);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * Callback method from {@link AvaluacioPerTestListFragment.Callbacks} indicating that
	 * the item with the given ID was selected.
	 */
	@Override
	public void onItemSelected(int id, int pos) {
		// In two-pane mode, show the detail view in this activity by
		// adding or replacing the detail fragment using a
		// fragment transaction.
		Bundle arguments = new Bundle();
		arguments.putInt("Test", id);
		AvaluacioPerTestDetailFragment fragment = new AvaluacioPerTestDetailFragment();
		fragment.setArguments(arguments);
		FragmentTransaction replace = getFragmentManager().beginTransaction()
				.replace(R.id.avaluaciopertest_detail_container, fragment);
		replace.commit();

		selectedTestsId = id;
	}
}
