package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;

import android.app.ActionBar;
import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.SparseArray;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.ub.alumnes.mmorenfe.pfg_app.ParticipantFragment.OnGetParticiPants;
import com.ub.alumnes.mmorenfe.pfg_app.model.Alumne;
import com.ub.alumnes.mmorenfe.pfg_app.model.Assignatura;

public class CrearAssignaturaActivity extends Activity implements
		ActionBar.TabListener, OnGetParticiPants {

	private boolean tab1Open = true;
	private boolean tab2Open = false;

	private SparseArray<Alumne> participants;
	private List<Alumne> alumnes;

	private DoDownloadAlumnes task;
	private DoCreateAssignatura taskAssignatura;

	/**
	 * The serialization (saved instance state) Bundle key representing the
	 * current tab position.
	 */
	private static final String STATE_SELECTED_NAVIGATION_ITEM = "selected_navigation_item";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_crear_assignatura);

		participants = new SparseArray<Alumne>();

		// Set up the action bar to show tabs.
		final ActionBar actionBar = getActionBar();
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);

		// For each of the sections in the app, add a tab to the action bar.
		actionBar.addTab(actionBar.newTab()
				.setText(R.string.title_section_assignatura)
				.setTabListener(this));
		actionBar.addTab(actionBar.newTab()
				.setText(R.string.title_section_participants)
				.setTabListener(this));
	}

	@Override
	public void onRestoreInstanceState(Bundle savedInstanceState) {
		// Restore the previously serialized current tab position.
		if (savedInstanceState.containsKey(STATE_SELECTED_NAVIGATION_ITEM)) {
			getActionBar().setSelectedNavigationItem(
					savedInstanceState.getInt(STATE_SELECTED_NAVIGATION_ITEM));
		}
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		// Serialize the current tab position.
		outState.putInt(STATE_SELECTED_NAVIGATION_ITEM, getActionBar()
				.getSelectedNavigationIndex());
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_crear_assignatura, menu);
		return true;
	}

	@Override
	public void onTabSelected(ActionBar.Tab tab,
			FragmentTransaction fragmentTransaction) {

		Fragment fragment = new Fragment();
		if (tab.getPosition() == 1 && !tab2Open) {
			getActionBar().setSelectedNavigationItem(1);
			fragment = new ParticipantFragment();
			tab2Open = true;
			tab1Open = false;

		} else if (tab.getPosition() == 0 && !tab1Open) {

			fragment = new DummySectionFragment();
			Bundle args = new Bundle();
			args.putInt(DummySectionFragment.ARG_SECTION_NUMBER,
					tab.getPosition() + 1);
			fragment.setArguments(args);

			getActionBar().setSelectedNavigationItem(0);
			tab2Open = false;
			tab1Open = true;
		}
		
		if (fragment instanceof AssignaturaFragment) {
			
		}

		getFragmentManager().beginTransaction()
				.replace(R.id.container, fragment).commit();
	}

	@Override
	public void onTabUnselected(ActionBar.Tab tab,
			FragmentTransaction fragmentTransaction) {
	}

	@Override
	public void onTabReselected(ActionBar.Tab tab,
			FragmentTransaction fragmentTransaction) {
	}

	@Override
	protected void onStart() {
		super.onStart();
		task = new DoDownloadAlumnes();
		task.execute();
		try {
			List<Alumne> alumnes = task.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}

		Assignatura a = new Assignatura();
		a.setAlumnes(alumnes);

		a.setId(0);
		a.setImatgePresentacio(null);
		a.setNom("nova assignatura");
		a.setTemes(null);

		taskAssignatura.execute(a);

		try {
			taskAssignatura.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
	}

	public static class DummySectionFragment extends Fragment {
		/**
		 * The fragment argument representing the section number for this
		 * fragment.
		 */
		public static final String ARG_SECTION_NUMBER = "section_number";

		public DummySectionFragment() {
		}

		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			// Create a new TextView and set its text to the fragment's section
			// number argument value.
			TextView textView = new TextView(getActivity());
			textView.setGravity(Gravity.CENTER);
			textView.setText(Integer.toString(getArguments().getInt(
					ARG_SECTION_NUMBER)));
			return textView;
		}

	}

	@Override
	public void getParticipants(SparseArray<Alumne> participants) {
		this.participants = participants;
	}

	private class DoCreateAssignatura extends
			AsyncTask<Assignatura, Void, Assignatura> {

		@Override
		protected Assignatura doInBackground(Assignatura... params) {
			Assignatura a = params[0];
			return a;
		}
	}

	public class DoDownloadAlumnes extends AsyncTask<Void, Void, List<Alumne>> {

		@Override
		protected List<Alumne> doInBackground(Void... params) {

			List<Alumne> alumnes = new ArrayList<Alumne>();
			return alumnes;
		}

	}

}
