package com.ub.alumnes.mmorenfe.pfg_app;

import android.app.ActionBar;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.widget.ArrayAdapter;

import com.ub.alumnes.mmorenfe.pfg_app.model.Tema;

public class DropdownMenu extends Activity implements
		ActionBar.OnNavigationListener {

	protected static final int TESTS = 0;
	protected static final int FITXERS = 1;
	protected static final int PARTICIPANTS = 2;
	protected static final int AVALUACIONS = 3;

	private Tema tema;

	/**
	 * The serialization (saved instance state) Bundle key representing the
	 * current dropdown position.
	 */
	private static final String STATE_SELECTED_NAVIGATION_ITEM = "selected_navigation_item";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// Set up the action bar to show a dropdown list.
		final ActionBar actionBar = getActionBar();
		// Show the Up button in the action bar.
		getActionBar().setDisplayHomeAsUpEnabled(true);

		actionBar.setDisplayShowTitleEnabled(false);
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_LIST);

		actionBar.setBackgroundDrawable(getResources().getDrawable(
				R.drawable.actionbar_background));

		// obtenim el tema al qual pertenyin els tests
		tema = getIntent().getParcelableExtra("Tema");

		// Set up the dropdown list navigation in the action bar.
		actionBar.setListNavigationCallbacks(
		// Specify a SpinnerAdapter to populate the dropdown
		// list.
				new ArrayAdapter<String>(actionBar.getThemedContext(),
						android.R.layout.simple_list_item_1,
						android.R.id.text1, new String[] {
								getString(R.string.title_tests),
								getString(R.string.title_fitxers), }), this);

	}

	@Override
	public void onRestoreInstanceState(Bundle savedInstanceState) {
		// Restore the previously serialized current dropdown position.
		if (savedInstanceState.containsKey(STATE_SELECTED_NAVIGATION_ITEM)) {
			getActionBar().setSelectedNavigationItem(
					savedInstanceState.getInt(STATE_SELECTED_NAVIGATION_ITEM));
		}
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		// Serialize the current dropdown position.
		outState.putInt(STATE_SELECTED_NAVIGATION_ITEM, getActionBar()
				.getSelectedNavigationIndex());
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_dropdown_menu, menu);
		return true;
	}

	@Override
	public boolean onNavigationItemSelected(int position, long id) {
		// When the given dropdown item is selected, show its contents in the
		// container view.
		switch (position) {
		case TESTS:

			if (!(this instanceof TestListActivity)) {
				Intent i = new Intent(getApplicationContext(),
						TestListActivity.class);
				i.putExtra("Tema", getTema());
				startActivity(i);
			}
			break;
		case FITXERS:
			if (!(this instanceof ArxiusActivity)) {
				Intent i = new Intent(getApplicationContext(),
						ArxiusActivity.class);
				i.putExtra("Tema", getTema());
				startActivity(i);
			}
			break;
		default:
			break;
		}
		return true;
	}

	protected Tema getTema() {
		return this.tema;
	}

}
