package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.concurrent.ExecutionException;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.DialogFragment;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.ub.alumnes.mmorenfe.pfg_app.model.Tema;

public class FragmentCrearTema extends DialogFragment {

	private View containerDialog;

	private View status;
	private View content;

	EditText etTitle;

	TextView textStatus;

	private DoCreateTema task;

	public interface OnCreateTema {

		public void onCreated(final Tema tema);
	}

	/**
	 * A dummy implementation of the {@link OnCreateTema} interface that does
	 * nothing. Used only when this fragment is not attached to an activity.
	 */
	private static OnCreateTema cDummy = new OnCreateTema() {

		@Override
		public void onCreated(final Tema tema) {

		}
	};

	private OnCreateTema cCallback = cDummy;

	public FragmentCrearTema() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Fragment#onCreateView(android.view.LayoutInflater,
	 * android.view.ViewGroup, android.os.Bundle)
	 */
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		containerDialog = inflater.inflate(R.layout.dialog_tema, container,
				false);
		return containerDialog;
	}

	@Override
	public void onAttach(Activity activity) {
		super.onAttach(activity);

		try {
			cCallback = (OnCreateTema) activity;
		} catch (ClassCastException e) {
			throw new ClassCastException(activity.toString()
					+ " must implement OnCreateTema");
		}
	}

	@Override
	public void onDetach() {
		super.onDetach();
		cCallback = cDummy;
	}

	@Override
	public void onStart() {
		super.onStart();

		status = containerDialog.findViewById(R.id.tema_status);
		content = containerDialog.findViewById(R.id.tema_content);

		Button b = (Button) containerDialog.findViewById(R.id.buttonSendTema);
		etTitle = (EditText) containerDialog
				.findViewById(R.id.editTextTitleTema);
		textStatus = (TextView) containerDialog
				.findViewById(R.id.tema_status_message);

		b.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				task = new DoCreateTema();
				task.execute("hola");
			}
		});
	}

	private void validate() {
		if (task != null) {
			return;
		}

		etTitle.setError(null);

		boolean cancel = false;
		View focusView = null;

		if (TextUtils.isEmpty(etTitle.getText().toString())) {
			etTitle.setError(getString(R.string.error_empty));
			cancel = true;
			focusView = etTitle;
		}

		if (cancel) {
			// There was an error; don't attempt login and focus the first
			// form field with an error.
			focusView.requestFocus();
		} else {
			// Show a progress spinner, and kick off a background task to
			// perform the user login attempt.
			textStatus.setText(R.string.status_tema_progress);
			showProgress(true);
			task = new DoCreateTema();
			task.execute(etTitle.getText().toString());

		}

	}

	private class DoCreateTema extends AsyncTask<String, Void, Tema> {

		@Override
		protected Tema doInBackground(String... params) {

			String title = params[0];

			Tema tema = new Tema(0, title, null, null);

			try {
				// Simulate network access.
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				return null;
			}

			return tema;
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see android.os.AsyncTask#onPostExecute(java.lang.Object)
		 */
		@Override
		protected void onPostExecute(Tema result) {
			task = null;
			showProgress(false);
			cCallback.onCreated(result);

			dismiss();
		}

	}

	/**
	 * Shows the progress UI and hides the login form.
	 */
	@TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
	private void showProgress(final boolean show) {
		// On Honeycomb MR2 we have the ViewPropertyAnimator APIs, which allow
		// for very easy animations. If available, use these APIs to fade-in
		// the progress spinner.
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB_MR2) {
			int shortAnimTime = getResources().getInteger(
					android.R.integer.config_shortAnimTime);

			status.setVisibility(View.VISIBLE);
			status.animate().setDuration(shortAnimTime).alpha(show ? 1 : 0)
					.setListener(new AnimatorListenerAdapter() {
						@Override
						public void onAnimationEnd(Animator animation) {
							status.setVisibility(show ? View.VISIBLE
									: View.GONE);
						}
					});

			content.setVisibility(View.VISIBLE);
			content.animate().setDuration(shortAnimTime).alpha(show ? 0 : 1)
					.setListener(new AnimatorListenerAdapter() {
						@Override
						public void onAnimationEnd(Animator animation) {
							content.setVisibility(show ? View.GONE
									: View.VISIBLE);
						}
					});
		} else {
			// The ViewPropertyAnimator APIs are not available, so simply show
			// and hide the relevant UI components.
			status.setVisibility(show ? View.VISIBLE : View.GONE);
			content.setVisibility(show ? View.GONE : View.VISIBLE);
		}
	}

}
