package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;

import android.app.Activity;
import android.app.Fragment;
import android.graphics.drawable.Drawable.Callback;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.CheckBox;
import android.widget.ListView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.ParticipantsAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Alumne;
import com.ub.alumnes.mmorenfe.pfg_app.model.Assignatura;
import com.ub.alumnes.mmorenfe.pfg_app.model.Missatge;

public class ParticipantFragment extends Fragment {
	
	private List<Alumne> alumnes;
	private View container;
	private ListView lvParticipants;
	private ParticipantsAdapter pa;
	
	private DoDownloadParticipants task;
	
	public interface OnGetParticiPants {
		public void getParticipants(final SparseArray<Alumne> participants);
	}
	
	private OnGetParticiPants pCallback = pDummy;
	
	
	/**
	 * A dummy implementation of the {@link OnGetParticiPants} interface that
	 * does nothing. Used only when this fragment is not attached to an
	 * activity.
	 */
	private static OnGetParticiPants pDummy = new OnGetParticiPants() {

		@Override
		public void getParticipants(final SparseArray<Alumne> participants) {
		}
	};
	
	public ParticipantFragment() {
		alumnes = new ArrayList<Alumne>();
	}

	@Override
	public void onAttach(Activity activity) {
		super.onAttach(activity);
		
		pCallback = (OnGetParticiPants) activity;
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		this.container = inflater.inflate(R.layout.layout_participants, container, false);
		return this.container;
	}

	@Override
	public void onDetach() {
		super.onDetach();
		pCallback = pDummy;
	}

	@Override
	public void onStart() {
		super.onStart();
		
		task = new DoDownloadParticipants();
		task.execute(new Assignatura());
		
		try {
			alumnes = task.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
		
		lvParticipants = (ListView) container.findViewById(R.id.listViewParticipants);
		pa = new ParticipantsAdapter(getActivity(), R.layout.participant_row, alumnes);
		
		lvParticipants.setAdapter(pa);
		
		lvParticipants.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View v,
					int arg2, long arg3) {
				CheckBox cb = (CheckBox) v.findViewById(R.id.checkBoxParticipant);
				if (cb.isChecked()) {
					cb.setChecked(false);
				} else {
					cb.setChecked(true);
				}
				//obtenim els participants selecionats.
				pCallback.getParticipants(pa.getParticipants());
			}
		});
		
		
	}
	
	protected SparseArray<Alumne> getParticipants() {
		return this.pa.getParticipants();
	}
	
	

	private class DoDownloadParticipants extends
			AsyncTask<Assignatura, Void, ArrayList<Alumne>> {

		@Override
		protected ArrayList<Alumne> doInBackground(Assignatura... params) {
			Assignatura assignatura = params[0];


			ArrayList<Alumne> alumnes = new ArrayList<Alumne>();

			Alumne a = new Alumne(1, 14740460, "47330568H", "Marc", "Moreno",
					new ArrayList<Missatge>(), new ArrayList<Missatge>());
			
			alumnes.add(a);
			
			
			return alumnes;
		}
	}

	
	
}
