package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.List;

import android.app.ActionBar;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.test.InstrumentationTestSuite;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ListView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.AssignaturaAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.adapters.TemaAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Assignatura;
import com.ub.alumnes.mmorenfe.pfg_app.model.Pregunta;
import com.ub.alumnes.mmorenfe.pfg_app.model.Tema;
import com.ub.alumnes.mmorenfe.pfg_app.model.Test;

public class TemaActivity extends Activity implements
		FragmentCrearTema.OnCreateTema {

	private ListView lv;
	private ListView lv2;
	
	private Button buttonParticipants;
	private Button buttonAvaluacions;
	
	private TemaAdapter ta;
	private AssignaturaAdapter aa;
	private Assignatura assignatura;
	private ArrayList<Assignatura> assignatures;
	private List<Tema> temes;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_tema);
		
		ActionBar bar = getActionBar();
		
		

		// guardem l'assignatura que conte tots els temes.
		assignatura = getIntent().getParcelableExtra("Assignatura");
		assignatures = getIntent().getParcelableArrayListExtra("Assignatures");
		
		bar.setTitle(assignatura.getNom());
		
		bar.setBackgroundDrawable(getResources().getDrawable(R.drawable.actionbar_background));

		lv = (ListView) findViewById(R.id.tema_grid);
		lv2 = (ListView) findViewById(R.id.assignaturesShortcut
				);
		
		buttonParticipants = (Button)findViewById(R.id.buttonParticipants);
		buttonAvaluacions = (Button) findViewById(R.id.buttonAvaluacions);

        SharedPreferences prefs = getSharedPreferences("account", MODE_PRIVATE);

        boolean isProfessor = prefs.getBoolean("isProfessor", false);

        if (!isProfessor) {
            buttonAvaluacions.setVisibility(View.GONE);
            buttonParticipants.setText("Qalificacions");
        }


        temes = new ArrayList<Tema>();

		temes = assignatura.getTemes();

		ta = new TemaAdapter(getApplicationContext(),
				R.layout.tema_grid_element, temes);
		
		aa = new AssignaturaAdapter(getApplicationContext(),
				R.layout.assignatura_row, assignatures);
		


		lv.setAdapter(ta);
		lv2.setAdapter(aa);
		
		ta.setNotifyOnChange(true);
		aa.setNotifyOnChange(true);
		

		lv.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				Intent i = new Intent(getApplicationContext(),
						TestListActivity.class);
				i.putExtra("Tema", temes.get(position));
				startActivity(i);
			}
		});
		
		lv2.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				Intent i = new Intent(getApplicationContext(),
						TemaActivity.class);
				i.putExtra("Assignatura", assignatures.get(position));
				i.putParcelableArrayListExtra("Assignatures", (ArrayList<Assignatura>) assignatures);
				startActivity(i);
				finish();
			}
		});
		
		buttonParticipants.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				
				Intent i = new Intent(getApplicationContext(),
						AvaluacioPerAlumnesListActivity.class);
				startActivity(i);
			}
		});
		
		buttonAvaluacions.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Intent i = new Intent(getApplicationContext(),
						AvaluacioPerTestListActivity.class);
				startActivity(i);
				
			}
		});
	}

    private void afegirTest() {
        if (assignatura.getNom().equals("Software concurrent")) {
            temes.get(0).getTests().add(new Test(124345345,"Primers Conceptes", new ArrayList<Pregunta>(),true));
        }
    }

	private ArrayList<Tema> generateHardcodedList() {
		ArrayList<Tema> temes = new ArrayList<Tema>();

		Tema t1 = new Tema(1, "tema 1", null, null);
		Tema t2 = new Tema(2, "tema 2", null, null);
		Tema t3 = new Tema(3, "tema 3", null, null);
		Tema t4 = new Tema(4, "tema 4", null, null);

		temes.add(t1);
		temes.add(t2);
		temes.add(t3);
		temes.add(t4);

		return temes;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_tema, menu);
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		return super.onOptionsItemSelected(item);

	}

	@Override
	public void onCreated(Tema tema) {
		temes.add(tema);
		ta.notifyDataSetChanged();
	}

}
