package com.ub.alumnes.mmorenfe.pfg_app;

import android.app.Fragment;
import android.content.Context;
import android.content.SharedPreferences;
import android.gesture.GestureOverlayView;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.*;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.PreguntaAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Test;
import com.ub.alumnes.mmorenfe.pfg_app.utils.TestUtils;

public class TestDetailFragment extends Fragment {

	private Test test;

	private TextView title;

    private TestUtils tUtils;

    private Button addPregunta;
	
	PreguntaAdapter pa;
	
	/**
	 * Mandatory empty constructor for the fragment manager to instantiate the
	 * fragment (e.g. upon screen orientation changes).
	 */
	public TestDetailFragment() {
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		if (getArguments().containsKey("Test")) {
			test = TestListFragment.testMap.get(getArguments().getInt("Test"));
		}

        tUtils = new TestUtils(getActivity().getApplicationContext());
    }

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View rootView = inflater.inflate(R.layout.fragment_test_detail,
				container, false);
		
		SharedPreferences preferences = getActivity().getApplicationContext()
				.getSharedPreferences("account", Context.MODE_PRIVATE);
		final boolean isProfessor = preferences.getBoolean("isProfessor", false);



        final LinearLayout ll = (LinearLayout) rootView.findViewById(R.id.preguntesContent);

        addPregunta = (Button) rootView.findViewById(R.id.buttonAddPregunta);

        if (!isProfessor) {
            addPregunta.setVisibility(View.GONE);
        }

        addPregunta.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                ll.addView(tUtils.generaLayoutPregunta(isProfessor,null));
            }
        });


//		ListView lv = (ListView)rootView.findViewById(R.id.listPreguntes);
		title = (TextView) rootView.findViewById(R.id.tvTitleTest);
		
//		pa = new PreguntaAdapter(getActivity(), R.layout.pregunta_test, test.getPreguntes(), isProfessor);
//		lv.setAdapter(pa);
		
		title.setText(test.getTitol());


        for (int i = 0; i < test.getPreguntes().size(); i++) {
            ll.addView(tUtils.generaLayoutPregunta(isProfessor, test.getPreguntes().get(i)));
        }

		
		if (preferences.getBoolean("isProfessor", false)) {
			
		}

		return rootView;
	}
	
	@Override
	public void onStart() {
		super.onStart();
	}
}
