package com.ub.alumnes.mmorenfe.pfg_app;

import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Toast;

import com.ub.alumnes.mmorenfe.pfg_app.model.Pregunta;
import com.ub.alumnes.mmorenfe.pfg_app.model.Tema;
import com.ub.alumnes.mmorenfe.pfg_app.model.Test;

public class TestListActivity extends DropdownMenu implements
		TestListFragment.Callbacks, FragmentCreateEditTest.OnCreateTest,
		FragmentCreateEditTest.OnEditTest,
		FragmentCreateEditTest.OnCreatePreguntaRequest,
		FragmentCreaPregunta.OnCreatePregunta {

	private final static int MODE_EDIT = 1;

	private final static int MODE_CREATE = 0;

	private final static int NO_MODE = -1;

	private final static int NO_MATTER = 999;

	private FragmentCreateEditTest fDialog;

	private FragmentCreaPregunta dialogPregunta;

	boolean isProfessor;

	private int selectedTestsId;

    private Tema tema;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		getActionBar().setSelectedNavigationItem(TESTS);

		setContentView(R.layout.activity_test_twopane);

		// In two-pane mode, list items should be given the
		// 'activated' state when touched.
		((TestListFragment) getFragmentManager().findFragmentById(
				R.id.test_list)).setActivateOnItemClick(true);

		SharedPreferences prefs = getSharedPreferences("account",
				Context.MODE_PRIVATE);
		isProfessor = prefs.getBoolean("isProfessor", false);

        tema = getIntent().getParcelableExtra("Tema");

	}

	/**
	 * Callback method from {@link TestListFragment.Callbacks} indicating that
	 * the item with the given ID was selected.
	 */
	@Override
	public void onItemSelected(int id, int pos) {
		// In two-pane mode, show the detail view in this activity by
		// adding or replacing the detail fragment using a
		// fragment transaction.
		Bundle arguments = new Bundle();
		arguments.putInt("Test", id);
		TestDetailFragment fragment = new TestDetailFragment();
		fragment.setArguments(arguments);
		FragmentTransaction replace = getFragmentManager().beginTransaction()
				.replace(R.id.test_detail_container, fragment);
		replace.commit();

		selectedTestsId = id;

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.

        if (isProfessor) {
            getMenuInflater().inflate(R.menu.activity_test, menu);
        } else {
            getMenuInflater().inflate(R.menu.activity_test_alumne, menu);
        }


		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		switch (item.getItemId()) {
		case android.R.id.home:
			// return home, that's AssignaturesActivity
			Intent i = new Intent(this, AssignaturesActivity.class);
			i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			startActivity(i);
			return true;
		case R.id.menu_enviar_test:
			if (isProfessor) {
				Toast.makeText(getApplicationContext(), "test enviat al servidor", Toast.LENGTH_LONG).show();
			} else {
                Toast.makeText(getApplicationContext(), "test enviat al servidor", Toast.LENGTH_LONG).show();
			}
			break;

            case R.id.menu_afegir_test:


                break;

		}
		return super.onOptionsItemSelected(item);

	}

	/**
	 * Shows the fragment with a form to create or edit one test.
	 * 
	 */
	private void showDialog(final Test t, final int mode) {
		FragmentManager fm = getFragmentManager();
		fDialog = new FragmentCreateEditTest(t, mode);
		fDialog.show(fm, "Test");
	}

	@Override
	public void onTestEdited(Test test) {
		fDialog.dismiss();
		FragmentManager fm = getFragmentManager();
		TestListFragment tlf = (TestListFragment) fm
				.findFragmentById(R.id.test_list);
		tlf.setTest(test);

		Bundle arguments = new Bundle();
		arguments.putInt("Test", test.getId());
		TestDetailFragment fragment = new TestDetailFragment();
		fragment.setArguments(arguments);
		FragmentTransaction replace = getFragmentManager().beginTransaction()
				.replace(R.id.test_detail_container, fragment);
		replace.commit();

		selectedTestsId = test.getId();

	}

	@Override
	public void onTestCreated(Test test) {
		fDialog.dismiss();

		FragmentManager fm = getFragmentManager();
		TestListFragment tlf = (TestListFragment) fm
				.findFragmentById(R.id.test_list);
		tlf.addTest(test);
	}

	@Override
	public void onRequest(final Test test) {
		// la peticio per crear una pregunta s'ha enviat
		fDialog.dismiss();
		FragmentManager fm = getFragmentManager();

		dialogPregunta = new FragmentCreaPregunta(test);
		dialogPregunta.show(fm, "Pregunta");
	}

	@Override
	public void onPreguntaCreated(final Test test) {

		FragmentManager fm = getFragmentManager();
		TestListFragment tlf = (TestListFragment) fm
				.findFragmentById(R.id.test_list);

		tlf.setTest(test);

		showDialog(TestListFragment.testMap.get(test.getId()), NO_MATTER);
	}

    protected Tema getTema() {
        return this.tema;
    }

}
