package com.ub.alumnes.mmorenfe.pfg_app;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.app.FragmentManager;
import android.app.ListFragment;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;

import com.ub.alumnes.mmorenfe.pfg_app.adapters.TestAdapter;
import com.ub.alumnes.mmorenfe.pfg_app.model.Pregunta;
import com.ub.alumnes.mmorenfe.pfg_app.model.Resposta;
import com.ub.alumnes.mmorenfe.pfg_app.model.Test;
public class TestListFragment extends ListFragment {

	private List<Test> tests;
	protected static Map<Integer, Test> testMap;
	
	private TestAdapter ta;
	
	private int currentPosition;

    private boolean flag = true;

	/**
	 * The serialization (saved instance state) Bundle key representing the
	 * activated item position. Only used on tablets.
	 */
	private static final String STATE_ACTIVATED_POSITION = "activated_position";

	/**
	 * The fragment's current callback object, which is notified of list item
	 * clicks.
	 */
	private Callbacks mCallbacks = sDummyCallbacks;

	/**
	 * The current activated item position. Only used on tablets.
	 */
	private int mActivatedPosition = ListView.INVALID_POSITION;

	/**
	 * A callback interface that all activities containing this fragment must
	 * implement. This mechanism allows activities to be notified of item
	 * selections.
	 */
	public interface Callbacks {
		/**
		 * Callback for when an item has been selected.
		 */
		public void onItemSelected(int id, int pos);
	}

	/**
	 * A dummy implementation of the {@link Callbacks} interface that does
	 * nothing. Used only when this fragment is not attached to an activity.
	 */
	private static Callbacks sDummyCallbacks = new Callbacks() {
		@Override
		public void onItemSelected(int id, int pos) {
		}
	};

	/**
	 * Mandatory empty constructor for the fragment manager to instantiate the
	 * fragment (e.g. upon screen orientation changes).
	 */
	public TestListFragment() {
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		SharedPreferences prefs = getActivity().getSharedPreferences("account",
				Context.MODE_PRIVATE);

		ta =new TestAdapter(getActivity(),
				R.layout.test_row_element, downloadTests(), prefs.getBoolean("isProfessor", false));
		setListAdapter(ta);
	}

	@Override
	public void onViewCreated(View view, Bundle savedInstanceState) {
		super.onViewCreated(view, savedInstanceState);

		// Restore the previously serialized activated item position.
		if (savedInstanceState != null
				&& savedInstanceState.containsKey(STATE_ACTIVATED_POSITION)) {
			setActivatedPosition(savedInstanceState
					.getInt(STATE_ACTIVATED_POSITION));
		}
	}
	
	

	@Override
	public void onStart() {
		super.onStart();
		ta.setNotifyOnChange(true);
		setActivateOnItemClick(true);
		
		getListView().setSelector(getResources().getDrawable(R.drawable.list_item_selector));
		
	}
	
	

	@Override
	public void onAttach(Activity activity) {
		super.onAttach(activity);

		testMap = new HashMap<Integer, Test>();

		// Activities containing this fragment must implement its callbacks.
		if (!(activity instanceof Callbacks)) {
			throw new IllegalStateException(
					"Activity must implement fragment's callbacks.");
		}

		mCallbacks = (Callbacks) activity;
	}

	@Override
	public void onDetach() {
		super.onDetach();

		// Reset the active callbacks interface to the dummy implementation.
		mCallbacks = sDummyCallbacks;
	}

	@Override
	public void onListItemClick(ListView listView, View view, int position,
			long id) {
		super.onListItemClick(listView, view, position, id);

        if (currentPosition == position && flag) {

            flag = false;
            currentPosition = position;
            setActivatedPosition(position);


            mCallbacks.onItemSelected(tests.get(position).getId(), position);
        } else if (currentPosition != position) {
            flag = true;
        }
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		if (mActivatedPosition != ListView.INVALID_POSITION) {
			// Serialize and persist the activated item position.
			outState.putInt(STATE_ACTIVATED_POSITION, mActivatedPosition);
		}
	}

	/**
	 * Turns on activate-on-click mode. When this mode is on, list items will be
	 * given the 'activated' state when touched.
	 */
	public void setActivateOnItemClick(boolean activateOnItemClick) {
		// When setting CHOICE_MODE_SINGLE, ListView will automatically
		// give items the 'activated' state when touched.
		getListView().setChoiceMode(
				activateOnItemClick ? ListView.CHOICE_MODE_SINGLE
						: ListView.CHOICE_MODE_NONE);
	}

	private void setActivatedPosition(int position) {
		if (position == ListView.INVALID_POSITION) {
			getListView().setItemChecked(mActivatedPosition, false);
		} else {
			getListView().setItemChecked(position, true);
		}

		mActivatedPosition = position;
	}

	private List<Test> downloadTests() {

		tests = new ArrayList<Test>();
		tests = generateHardcodedList();

		for (Test test : tests) {
			testMap.put(test.getId(), test);
		}

		return tests;
	}


	private List<Test> generateHardcodedList() {

        Test t = new Test(124345345,"Primers Conceptes", new ArrayList<Pregunta>(),true);

        List<Test> tests = new ArrayList<Test>();



        List<Resposta> respostes = new ArrayList<Resposta>(4);

        List<Pregunta> preguntes = new ArrayList<Pregunta>();

        // pregunta 1 del test 1
		Pregunta p1t1 = new Pregunta(1, "Com es diu el professor d'aquesta assignatura?", respostes);

		//respostes pre la pregunta 2 del test 1
		Resposta r1p1t1 = new Resposta(5, "Lluís", true);
		Resposta r2p1t1 = new Resposta(6, "Santi", false);
		Resposta r3p1t1 = new Resposta(7, "Oriol", false);
		Resposta r4p1t1 = new Resposta(8, "Carles",false);


        respostes.add(r1p1t1);
        respostes.add(r2p1t1);
        respostes.add(r3p1t1);
        respostes.add(r4p1t1);

        p1t1.setRespostes(respostes);
        preguntes.add(p1t1);

        t.setPreguntes(preguntes);

        tests.add(t);

        return tests;
	}
	
	public void addTest(final Test test) {
		tests.add(test);
		if (testMap.containsKey(test.getId())) {
			testMap.remove(test.getId());
		}
		ta.notifyDataSetChanged();
		
	}
	
	public void setTest (final Test test) {
		
		for (int i = 0; i < tests.size(); i++) {
			if (tests.get(i).getId() == test.getId()) {
				tests.set(i, test);
			}
		}
		
		ta.notifyDataSetChanged();
	}
	
	
}
