package com.ub.alumnes.mmorenfe.pfg_app.adapters;

import java.io.File;
import java.util.List;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.annotation.TargetApi;
import android.app.NotificationManager;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Environment;
import android.support.v4.app.NotificationCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.*;

import com.ub.alumnes.mmorenfe.pfg_app.R;
import com.ub.alumnes.mmorenfe.pfg_app.model.Arxiu;

public class ArxiuAdapter extends ArrayAdapter<Arxiu> {

	private int resourceId;
	private Context context;
	private boolean isProfessor;

    DoDownloadFile task;

	public ArxiuAdapter(Context context, int resourceId, List<Arxiu> objects,
			final boolean isProfessor) {
		super(context, resourceId, objects);
		this.context = context;
		this.resourceId = resourceId;
		this.isProfessor = isProfessor;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View v = null;
		LayoutInflater inflater = (LayoutInflater) context
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

		v = inflater.inflate(resourceId, parent, false);

		final ProgressBar progress = (ProgressBar) v.findViewById(R.id.progressBarFile);

		TextView title = (TextView) v.findViewById(R.id.textFileTitle);
		final ImageButton btnDownload = (ImageButton) v.findViewById(R.id.btnDownloadFile);

		title.setText(getItem(position).getNom());

        Switch sc = (Switch) v.findViewById(R.id.switchFile);

        SharedPreferences prefs = context.getSharedPreferences("account", context.MODE_PRIVATE);

        boolean isProfessor = prefs.getBoolean("isProfessor", false);

        if (!isProfessor) {
            sc.setVisibility(View.GONE);
        }

        btnDownload.setOnClickListener(new OnClickListener() {

            @Override
        public void onClick(View v) {
            showProgress(true, progress, btnDownload);
            task = new DoDownloadFile();
            task.execute(new Arxiu(), progress, btnDownload);

            }
        });

		return v;
	}

	private class DoDownloadFile extends AsyncTask<Object, Void, Arxiu> {
		
		Arxiu arxiu;
		ProgressBar progress;
		ImageButton b;
		

		@Override
		protected Arxiu doInBackground(Object... params) {
			
			arxiu = (Arxiu)params[0];
			progress = (ProgressBar) params[1];
			b = (ImageButton) params[2];
			
			try {
				// Simulate network access.
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				return null;
			}
			return null;
		}

		@Override
		protected void onPostExecute(Arxiu result) {
			super.onPostExecute(result);
			showProgress(false, progress, b);

            File file = new File(Environment.getExternalStorageDirectory().getAbsoluteFile()+"/Documents/pdf.pdf");
            if (file.exists())
            {
                Intent intent=new Intent(Intent.ACTION_VIEW);
                Uri uri = Uri.fromFile(file);
                intent.setDataAndType(uri, "application/pdf");
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);

                try
                {
                    context.startActivity(intent);
                }
                catch(ActivityNotFoundException e)
                {


                    Toast.makeText(context, "No hi ha cap aplicació disponible per obrir el pdf", Toast.LENGTH_LONG).show();
                }
            }





		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see android.os.AsyncTask#onProgressUpdate(Progress[])
		 */
		@Override
		protected void onProgressUpdate(Void... values) {

			super.onProgressUpdate(values);
		    }

	}

	/**
	 * Shows the progress UI and hides the login form.
	 */
	@TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
	private void showProgress(final boolean show, final ProgressBar progress,
			final ImageButton btnDownload) {
		// On Honeycomb MR2 we have the ViewPropertyAnimator APIs, which allow
		// for very easy animations. If available, use these APIs to fade-in
		// the progress spinner.
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB_MR2) {
			int shortAnimTime = context.getResources().getInteger(
					android.R.integer.config_shortAnimTime);

			progress.setVisibility(View.VISIBLE);
			progress.animate().setDuration(shortAnimTime).alpha(show ? 1 : 0)
					.setListener(new AnimatorListenerAdapter() {
						@Override
						public void onAnimationEnd(Animator animation) {
							progress.setVisibility(show ? View.VISIBLE
									: View.GONE);
						}
					});

			btnDownload.setVisibility(View.VISIBLE);
			btnDownload.animate().setDuration(shortAnimTime)
					.alpha(show ? 0 : 1)
					.setListener(new AnimatorListenerAdapter() {
						@Override
						public void onAnimationEnd(Animator animation) {
							btnDownload.setVisibility(show ? View.GONE
									: View.VISIBLE);
						}
					});
		} else {
			// The ViewPropertyAnimator APIs are not available, so simply show
			// and hide the relevant UI components.
			progress.setVisibility(show ? View.VISIBLE : View.GONE);
			btnDownload.setVisibility(show ? View.GONE : View.VISIBLE);
		}
	}

}
