package com.ub.alumnes.mmorenfe.pfg_app.adapters;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.ub.alumnes.mmorenfe.pfg_app.R;
import com.ub.alumnes.mmorenfe.pfg_app.model.Assignatura;
import com.ub.alumnes.mmorenfe.pfg_app.model.Professor;

public class AssignaturaAdapter extends ArrayAdapter<Assignatura> {
	
	private Context context;
	private int resourceId;

	public AssignaturaAdapter(Context context, int resourceId,
			List<Assignatura> objects) {
		super(context, resourceId, objects);
		this.context = context;
		this.resourceId = resourceId;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View view = null;

		if (convertView == null) {
			LayoutInflater inflater = (LayoutInflater) context
					.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			view = inflater.inflate(resourceId, parent,
					false);

			TextView titol = (TextView) view
					.findViewById(R.id.text_grid_assignatura_element);
			
			TextView subtitle = (TextView)view.findViewById(R.id.textViewAssignaturaSubtitle);
			
			Professor coordinador = getItem(position).getProfessors().get(0);
			subtitle.setText(coordinador.getNom() + " " + coordinador.getCognom());

			titol.setText(getItem(position).getNom());
		} else {
			view = convertView;

		}

		return view;
	}
}
