package com.ub.alumnes.mmorenfe.pfg_app.adapters;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.content.Context;
import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.TextView;

import com.ub.alumnes.mmorenfe.pfg_app.R;
import com.ub.alumnes.mmorenfe.pfg_app.model.Alumne;

public class ParticipantsAdapter extends ArrayAdapter<Alumne> {

	private Context context;
	private int resourceId;

	private SparseArray<Alumne> participants;

	public ParticipantsAdapter(Context context, int resourceId,
			List<Alumne> objects) {
		super(context, resourceId, objects);
		this.context = context;
		this.resourceId = resourceId;

		participants = new SparseArray<Alumne>();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ArrayAdapter#getView(int, android.view.View,
	 * android.view.ViewGroup)
	 */
	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {

		LayoutInflater inflater = (LayoutInflater) context
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		View v = inflater.inflate(resourceId, parent, false);

		CheckBox cb = (CheckBox) v.findViewById(R.id.checkBoxParticipant);
		TextView nom = (TextView) v.findViewById(R.id.textViewNomAlumne);

		nom.setText(getItem(position).getNom() + " "
				+ getItem(position).getCognom());
		cb.setChecked(false);

		cb.setOnCheckedChangeListener(new OnCheckedChangeListener() {

			@Override
			public void onCheckedChanged(CompoundButton buttonView,
					boolean isChecked) {
				if (isChecked) {
					participants.put(position, getItem(position));
				} else if (!isChecked && participants.get(position) != null) {
					participants.delete(position);
				}

			}
		});

		return v;
	}

	public SparseArray<Alumne> getParticipants() {
		return this.participants;
	}

}
