package com.ub.alumnes.mmorenfe.pfg_app.adapters;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CompoundButton;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.ToggleButton;

import com.ub.alumnes.mmorenfe.pfg_app.R;
import com.ub.alumnes.mmorenfe.pfg_app.model.Test;

public class TestAdapter extends ArrayAdapter<Test> {

	private int resourceId;
	private Context context;
	private LayoutInflater inflater;
	private boolean isProfessor;

	public TestAdapter(final Context context, final int resourceId,
			final List<Test> objects, final boolean isProfessor) {
		super(context, resourceId, objects);
		this.context = context;
		this.resourceId = resourceId;
		this.isProfessor = isProfessor;
		inflater = (LayoutInflater) context
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View v = new View(context);

		Test t = getItem(position);

			v = inflater.inflate(resourceId, parent, false);

			TextView tv = (TextView) v.findViewById(R.id.text_test);
			Switch sch = (Switch) v.findViewById(R.id.switch_test);

			if (!isProfessor) {
				sch.setVisibility(View.INVISIBLE);
			}

			tv.setText(t.getTitol());
			sch.setChecked(t.isVisible());



		return v;
	}

}
