package com.ub.alumnes.mmorenfe.pfg_app.model;

import java.util.ArrayList;
import java.util.List;

import android.os.Parcel;
import android.os.Parcelable;


/**
 * Classe que representa a una assignatura.
 * @author Marc Moreno Ferrer
 *
 */
public class Assignatura implements Parcelable {
	
	private int id;
	
	private String nom;
	
	private List<Tema> temes;
	
	private List<Alumne> alumnes;
	
	private List<Professor> professors;
	
	private Arxiu imatgePresentacio;

	public Assignatura(int id, String nom, List<Tema> temes,
			List<Alumne> alumnes, List<Professor> professors,
			Arxiu imatgePresentacio) {
		super();
		this.id = id;
		this.nom = nom;
		this.temes = temes;
		this.alumnes = alumnes;
		this.professors = professors;
		this.imatgePresentacio = imatgePresentacio;
	}

	public Assignatura() {
		super();
	}
	
	public Assignatura(final Parcel in) {
		super();
		id = in.readInt();
		nom = in.readString();
		temes = new ArrayList<Tema>();
		in.readList(temes, getClass().getClassLoader());
		alumnes = new ArrayList<Alumne>();
		in.readList(alumnes, getClass().getClassLoader());
		professors = new ArrayList<Professor>();
		in.readList(professors, getClass().getClassLoader());
		imatgePresentacio = in.readParcelable(getClass().getClassLoader());
	}
	
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(id);
		dest.writeString(nom);
		dest.writeList(temes);
		dest.writeList(alumnes);
		dest.writeList(professors);
		dest.writeParcelable(imatgePresentacio, flags);
	}
	
	public static final Parcelable.Creator CREATOR = new Parcelable.Creator() {
        public Assignatura createFromParcel(Parcel source) {
        	return new Assignatura(source);
        }
 
        public Assignatura[] newArray(int size) {
            return new Assignatura[size];
        }
    };

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}

	/**
	 * @return the temes
	 */
	public List<Tema> getTemes() {
		return temes;
	}

	/**
	 * @return the alumnes
	 */
	public List<Alumne> getAlumnes() {
		return alumnes;
	}

	/**
	 * @return the professors
	 */
	public List<Professor> getProfessors() {
		return professors;
	}

	/**
	 * @return the imatgePresentacio
	 */
	public Arxiu getImatgePresentacio() {
		return imatgePresentacio;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}

	/**
	 * @param temes the temes to set
	 */
	public void setTemes(List<Tema> temes) {
		this.temes = temes;
	}

	/**
	 * @param alumnes the alumnes to set
	 */
	public void setAlumnes(List<Alumne> alumnes) {
		alumnes = alumnes;
	}

	/**
	 * @param professors the professors to set
	 */
	public void setProfessors(List<Professor> professors) {
		this.professors = professors;
	}

	/**
	 * @param imatgePresentacio the imatgePresentacio to set
	 */
	public void setImatgePresentacio(Arxiu imatgePresentacio) {
		this.imatgePresentacio = imatgePresentacio;
	}

	@Override
	public int describeContents() {
		return 0;
	}


	
	
	
	

}
