package com.ub.alumnes.mmorenfe.pfg_app.model;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Clase que representa la valoracio numerica entre un alumne i un test.
 * 
 * @author Marc Moreno Ferrer
 * 
 */
public class Avaluacio implements Parcelable {

	/** El test a avaluar. */
	private Test test;

	/** la valoracio del test de 0 a 10. */
	private float nota;
	
	/**id per poder posarla com a parametre a la peticio al servidor.*/
	private int id;

	public Avaluacio(Test test, float nota, int id) {
		super();
		this.test = test;
		this.nota = nota;
		this.id = id;
	}

	public Avaluacio() {
		super();
	}
	
	public Avaluacio(Parcel source) {
		test = source.readParcelable(getClass().getClassLoader());
		nota = source.readFloat();
		id = source.readInt();
	}
	
	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeParcelable(test, flags);
		dest.writeFloat(nota);
		dest.writeInt(id);
	}
	
	public static final Parcelable.Creator CREATOR = new Parcelable.Creator() {
        public Avaluacio createFromParcel(Parcel source) {
        	return new Avaluacio(source);
        }
 
        public Avaluacio[] newArray(int size) {
            return new Avaluacio[size];
        }
    };

	/**
	 * @return the test
	 */
	public Test getTest() {
		return test;
	}

	/**
	 * @return the nota
	 */
	public float getNota() {
		return nota;
	}

	/**
	 * @param test
	 *            the test to set
	 */
	public void setTest(Test test) {
		this.test = test;
	}

	/**
	 * @param nota
	 *            the nota to set
	 */
	public void setNota(final float nota) {
		this.nota = nota;
	}
	
	

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**Avalua una nota i dona el resultat qualitatiu.
	 * @return el resultat de l-avaluacio
	 */
	public String getAvaluacioQualitativa() {
		String result = "";
		switch((int) nota) {
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
			result = "suspes";
			break;
		case 5:
			result = "suficient";
			break;
		case 6:
			result = "aprobat";
			break;
		case 7:
		case 8:
			result = "notable";
			break;
		case 9:
			result = "excelent";
			break;
		case 10:
			result = "MH";
			break;
		default:
			result = "nota no computable";
			break;
		}
		return result;
	}




}
