package com.ub.alumnes.mmorenfe.pfg_app.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import android.os.Parcel;
import android.os.Parcelable;

public class Missatge implements Parcelable {
	
	private int id;
	
	private String titol;
	
	private String text;
	
	private Date horaEnviat;
	
	private List<Usuari> receptors;

	public Missatge(int id, String titol, String text, Date horaEnviat,
			List<Usuari> receptors) {
		super();
		this.id = id;
		this.titol = titol;
		this.text = text;
		this.horaEnviat = horaEnviat;
		this.receptors = receptors;
	}
	
	public Missatge(final Parcel in) {
		super();
		id = in.readInt();
		titol = in.readString();
		text = in.readString();
		horaEnviat = new Date (in.readLong());
		receptors = new ArrayList<Usuari>();
		in.readList(receptors, getClass().getClassLoader());
	}
	
	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(id);
		dest.writeString(titol);
		dest.writeString(text);
		dest.writeLong( horaEnviat.getTime() );
		dest.writeList(receptors);
	}
	
	public static final Parcelable.Creator CREATOR = new Parcelable.Creator() {
        public Missatge createFromParcel(Parcel source) {
        	return new Missatge(source);
        }
 
        public Missatge[] newArray(int size) {
            return new Missatge[size];
        }
    };

    
	public Missatge() {
		super();
	}

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return the titol
	 */
	public String getTitol() {
		return titol;
	}

	/**
	 * @return the text
	 */
	public String getText() {
		return text;
	}

	/**
	 * @return the horaEnviat
	 */
	public Date getHoraEnviat() {
		return horaEnviat;
	}

	/**
	 * @return the receptors
	 */
	public List<Usuari> getReceptors() {
		return receptors;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param titol the titol to set
	 */
	public void setTitol(String titol) {
		this.titol = titol;
	}

	/**
	 * @param text the text to set
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * @param horaEnviat the horaEnviat to set
	 */
	public void setHoraEnviat(Date horaEnviat) {
		this.horaEnviat = horaEnviat;
	}

	/**
	 * @param receptors the receptors to set
	 */
	public void setReceptors(List<Usuari> receptors) {
		this.receptors = receptors;
	}


	
	

}
