package com.ub.alumnes.mmorenfe.pfg_app.model;

import java.util.ArrayList;
import java.util.List;

import android.os.Parcel;
import android.os.Parcelable;

public class Pregunta implements Parcelable{
	
	private int id;
	
	private String text;
	
	private List<Resposta> respostes;

	public Pregunta(int id, String text, List<Resposta> respostes) {
		super();
		this.id = id;
		this.text = text;
		this.respostes = respostes;
	}
	
	public Pregunta (final Parcel in) {
		id = in.readInt();
		text = in.readString();
		respostes = new ArrayList<Resposta>();
		in.readList(respostes, getClass().getClassLoader());
	}
	
	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(id);
		dest.writeString(text);
		dest.writeList(respostes);
	}
	
	public static final Parcelable.Creator CREATOR = new Parcelable.Creator() {
        public Pregunta createFromParcel(Parcel source) {
        	return new Pregunta(source);
        }
 
        public Pregunta[] newArray(int size) {
            return new Pregunta[size];
        }
    };

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return the text
	 */
	public String getText() {
		return text;
	}

	/**
	 * @return the respostes
	 */
	public List<Resposta> getRespostes() {
		return respostes;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param text the text to set
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * @param respostes the respostes to set
	 */
	public void setRespostes(List<Resposta> respostes) {
		this.respostes = respostes;
	}
	
	public int getRespostaCorrecta() {
		int index = -1;
		for (int i = 0; i < getRespostes().size(); i++) {
			if (getRespostes().get(i).isCorrecta()) {
				index = i;
			}
		}
		return index;
	}
	
	public void setRespostaCorrecta(final int pos) {
		for (int i = 0; i < respostes.size(); i++) {
			if (i == pos) {
				respostes.get(i).setCorrecta(true);
			} else {
				respostes.get(i).setCorrecta(false);
			}
		}
	}


	
	

}
