package com.ub.alumnes.mmorenfe.pfg_app.model;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Classe que representa una resposat d'un test.
 * @author Marc Moreno Ferrer
 *
 */
public class Resposta implements Parcelable {
	
	private int id;
	
	private String text;
	
	private boolean correcta;

	public Resposta(int id, String text, boolean correcta) {
		super();
		this.id = id;
		this.text = text;
		this.correcta = correcta;
	}
	
	public Resposta(final Parcel in) {
		id = in.readInt();
		text = in.readString();
		correcta = in.readByte() == 1;
	}

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return the text
	 */
	public String getText() {
		return text;
	}

	/**
	 * @return the correcta
	 */
	public boolean isCorrecta() {
		return correcta;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param text the text to set
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * @param correcta the correcta to set
	 */
	public void setCorrecta(boolean correcta) {
		this.correcta = correcta;
	}

	@Override
	public int describeContents() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(id);
		dest.writeString(text);
		dest.writeByte((byte) (correcta ? 1 : 0)); 
		
	}
	
	public static final Parcelable.Creator CREATOR = new Parcelable.Creator() {
        public Resposta createFromParcel(Parcel source) {
        	return new Resposta(source);
        }
 
        public Resposta[] newArray(int size) {
            return new Resposta[size];
        }
    };
	
	
	
	

}
