package com.ub.alumnes.mmorenfe.pfg_app.model;

import java.util.List;

import android.os.Parcel;
import android.os.Parcelable;

public abstract class Usuari implements Parcelable {
	
	private int id;
	
	private int niub;
	
	private String dni;
	
	private String nom;
	
	private String cognom;
	
	private List<Missatge> missatgesRebuts;
	
	private List<Missatge> missatgesEnviats;

	public Usuari(int id, int niub, String dni, String nom, String cognom,
			List<Missatge> missatgesRebuts, List<Missatge> missatgesEnviats) {
		super();
		this.id = id;
		this.niub = niub;
		this.dni = dni;
		this.nom = nom;
		this.cognom = cognom;
		this.missatgesRebuts = missatgesRebuts;
		this.missatgesEnviats = missatgesEnviats;
	}
	
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(id);
		dest.writeInt(niub);
		dest.writeString(dni);
		dest.writeString(nom);
		dest.writeString(cognom);
		dest.writeList(missatgesRebuts);
		dest.writeList(missatgesEnviats);
	}
	
	public Usuari (Parcel source) {
		id = source.readInt();
		niub = source.readInt();
		dni = source.readString();
		nom= source.readString();
		cognom = source.readString();
		source.readList(missatgesRebuts, getClass().getClassLoader());
		source.readList(missatgesEnviats, getClass().getClassLoader());
	}
	
	public Usuari() {
		
	}


	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return the niub
	 */
	public int getNiub() {
		return niub;
	}

	/**
	 * @return the dni
	 */
	public String getDni() {
		return dni;
	}

	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}

	/**
	 * @return the cognom
	 */
	public String getCognom() {
		return cognom;
	}

	/**
	 * @return the missatgesRebuts
	 */
	public List<Missatge> getMissatgesRebuts() {
		return missatgesRebuts;
	}

	/**
	 * @return the missatgesEnviats
	 */
	public List<Missatge> getMissatgesEnviats() {
		return missatgesEnviats;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @param niub the niub to set
	 */
	public void setNiub(int niub) {
		this.niub = niub;
	}

	/**
	 * @param dni the dni to set
	 */
	public void setDni(String dni) {
		this.dni = dni;
	}

	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}

	/**
	 * @param cognom the cognom to set
	 */
	public void setCognom(String cognom) {
		this.cognom = cognom;
	}

	/**
	 * @param missatgesRebuts the missatgesRebuts to set
	 */
	public void setMissatgesRebuts(List<Missatge> missatgesRebuts) {
		this.missatgesRebuts = missatgesRebuts;
	}

	/**
	 * @param missatgesEnviats the missatgesEnviats to set
	 */
	public void setMissatgesEnviats(List<Missatge> missatgesEnviats) {
		this.missatgesEnviats = missatgesEnviats;
	}
	

	
	

}
