package com.ub.alumnes.mmorenfe.pfg_app.utils;

import java.util.ArrayList;
import java.util.List;

public class ChartUtils {

	public static final int LINE_CHART = 0;
	public static final int PIE_CHART = 1;

	public static final String BASE_URL_LINE_CHART = "http://chart.googleapis.com/chart?chxr=0,0,10&chxt=y&chs=300x225&cht=lc&chco=3D7930,FF9900&chds=0,10,0,10&chd=t:{VALUES}&chg=14.3,-1,1,1&chls=2,4,0|2&chm=B,C5D4B5BB,0,0,0";

	public static final String BASE_URL_PIE_CHART = "http://chart.googleapis.com/chart?chs=300x225&cht=p&chco=3A75C4&chd=t:{VALUES}&chl=MH|EX|N|A|S";
	public static final String SPACE = "%20";

	// _________________________parametre cht _____________________//

	/** diagrama de linies. */
	public static final String LC = "lc";

	/** diagrama de linies combinat. */
	public static final String LXY = "lxy";

	/** diagrama de formatge. */
	public static final String P = "p";

	/** diagrama de formatge amb subdiagrama centric. */
	public static final String PC = "pc";

	public static final String P3 = "p3";

	/** the tipe of chart */
	private String cht;

	// _________________________parametre chs_____________________//

	/** amplada. */
	public static final String WIDTH = "{width}";

	/** alsada. */
	public static final String HEIGHT = "{height}";

	/** definicio de ampladaxalsada. */
	public static final String SIZE = WIDTH + "X" + HEIGHT;

	/** la mida en pixels de la imatge */
	private String chs;

	// _________________________parametre chd_____________________//

	/** el contenidor dels valors per a cada tipus d'element del chart. */
	private String chd;

	private List<String> values;

	// _________________________parametre chl_____________________//

	/** el nom de les variables del chart. */
	private String chl;

	private List<String> things;

	// _________________________parametre chtt_____________________//

	/** titol del chart. */
	private String chtt;

	// _________________________parametre chco_____________________//

	/** el color del chart. */
	private String chco;

	private String query;

	/**
	 * Constructor per generar un line chart
	 * 
	 * @param values
	 *            la llista de valors a dibuixar, han de valer entre 0 i 10.
	 */
	public ChartUtils(final List<Float> values, final List<Float> mean) {
		query = "";
		String result = "";

		// precondicio: la mida dels dos vectors ha de ser igual.
		assert values.size() == mean.size();

		if (values.size() >= 1) {
			result += String.valueOf(values.get(0)) + ",";
			if (values.size() > 1) {
				for (int i = 1; i < values.size(); i++) {
					if (i == values.size() - 1) {
						result += String.valueOf(values.get(i)) + "|";
					} else {
						result += String.valueOf(values.get(i)) + ",";
					}
				}
			}
		}

		if (mean.size() > 1) {
			result += String.valueOf(mean.get(0)) + ",";
			if (mean.size() >= 1) {
				for (int i = 1; i < mean.size(); i++) {
					if (i == values.size() - 1) {
						result += String.valueOf(mean.get(i));
					} else {
						result += String.valueOf(mean.get(i)) + ",";
					}
				}
			}
		}
		query = BASE_URL_LINE_CHART.replace("{VALUES}", result);
	}

	public ChartUtils(final int mh, final int excelent, final int notable,
			final int aprobat, final int suspes) {
		query = "";
		String result = mh + "," + excelent + "," + notable + "," + aprobat + "," + suspes;
		
		query = BASE_URL_PIE_CHART.replace("{VALUES}", result);

	}

	public String getQuery() {
		return this.query;
	}

}
